package com.eactive.eai.batch.job.jobItem.welcd;

import java.io.ByteArrayOutputStream;
import java.util.Properties;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.batch.common.CommonKeys;
import com.eactive.eai.common.exception.ExceptionUtil;

public class SEND_WELCD_0600 extends DefaultTelegram implements TelegramService
{

    private int SEND_LENGTH;       //TCP/IP전문 송신 BYTES수로 "업무구분코드"이후의 송신할 전문 길이
    private int REAL_SEND_LENGTH;  //실제 송신할 전문의 총길이

    private Properties telegramInfo;
    /**
     * 생성자
     */
    public SEND_WELCD_0600() {
        //업무개시요구 및 업무개시통보
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {
            boolean result = calculateSendLength();
            if (!result) return false;

            String procType = batchDoc.getBatchMsg().getHeader().getProcessType();

            //TRANSACTION CODE
            if ( procType.equalsIgnoreCase(CommonKeys.PROCESS_REQUEST_SEND) ||
            		procType.equalsIgnoreCase(CommonKeys.PROCESS_REQUEST_RECEIVE) ){
                batchDoc.getBatchMsg().getHeader().setTRXID(telegramInfo.getProperty(TelegramKeys.TRANSACTION_CODE));
            }
            compileField(0, batchDoc.getBatchMsg().getHeader().getTRXID(), this.al_FieldProps[0]);

            //업무구분코드 - 센터 및 은행에서 업무구분을 위하여 SET
            compileField(1, telegramInfo.getProperty(TelegramKeys.BIZ_GBN), this.al_FieldProps[1]);

            //전송길이
            compileField(2, "" + REAL_SEND_LENGTH, this.al_FieldProps[2]);

            //기관코드
            compileField(3, telegramInfo.getProperty(TelegramKeys.BANK_CODE), this.al_FieldProps[3]);

            //전문종별코드. 전문의 기능을 나타냄.
            compileField(4, this.getFldTelegramType(), this.al_FieldProps[4]);

            //거래구분코드CARD송신업무"S", CARD수신업무 "R"
            if ( procType.equalsIgnoreCase(CommonKeys.PROCESS_REQUEST_SEND) ||
                    procType.equalsIgnoreCase(CommonKeys.PROCESS_RESPONSE_SEND)) {
                compileField(5, telegramInfo.getProperty(TelegramKeys.TRAN_GBN_SEND), this.al_FieldProps[5]);
            }else{
                compileField(5, telegramInfo.getProperty(TelegramKeys.TRAN_GBN_RECV), this.al_FieldProps[5]);
            }

            //송수신 FLAG 전문발생기관 (B:e-제너두, C:Card)
            compileField(6, telegramInfo.getProperty(TelegramKeys.TRA_FLAG_CENTER), this.al_FieldProps[6]);

            //화일명
            if ( "001|004".indexOf(this.getFldOpCode()) > -1){
                compileField(7, "", this.al_FieldProps[7]);
            } else {
                compileField(7, batchDoc.getBatchMsg().getHeader().getFileName(), this.al_FieldProps[7]);
            }

            //응답코드
            compileField(8, this.getResolveResponseCode(), this.al_FieldProps[8]);

            //전문 전송 일시 (MMddhhmmss)
            compileField(9, TelegramKeys.getMMddHHmmss(), this.al_FieldProps[9]);

            //업무관리정보. CMS 업무 관리를 위한 코드.
            //001-업무개시, 002-화일 송수신 완료(송신할 화일 존재), 003-화일 송수신 완료(송신할 화일 없음), 004-업무종료
            compileField(10, this.getFldOpCode(), this.al_FieldProps[10]);

            //송신자명
            compileField(11, "", this.al_FieldProps[11]);
            //<< 전문 완성
            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }

    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        try {
            return REAL_SEND_LENGTH;  //실 DATA BYTE수
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI013";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    public boolean doPreExecute() {
        try {
            if (!super.doPreExecute()) return false;
            telegramInfo = getTelegramInfo();
            try {
				int sleepTime = Integer.parseInt(telegramInfo.getProperty(TelegramKeys.SLEEP_TIME));
				Thread.sleep(sleepTime); 
			} catch (Exception e) {}
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    public boolean doPostExecute() {
        if (!super.doPostExecute()) return false;
        try {
            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<9; i++) { //CMS전문의 헤더는 응답코드까지 임.
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=9; i< al_Field.size(); i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            return true;

        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    private boolean calculateSendLength () {
        try {
            for (int i=3; i< this.al_Field.size(); i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                SEND_LENGTH += aField.length;
            }
            REAL_SEND_LENGTH = SEND_LENGTH;
            for (int i=0; i< 3; i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                REAL_SEND_LENGTH += aField.length;
            }
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
        return super.getFieldValueString(4);
    }
    // 거래구분코드 필드값 리턴
    public String getTrClass()
    {
        return super.getFieldValueString(5);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
        return super.getFieldValueString(8);
    }
    //업무관리코드 필드값 리턴
    public String getOpCode()
    {
        return super.getFieldValueString(10);
    }
}